Subject: Re: RFC: Flat directory for notes, or fan-out? Both!

From: Sam Vilain <[email-masked]>
Date: Wed, 11 Feb 2009 16:30:10 +1300

Linus Torvalds wrote:
> That sounds unnecessarily complicated. It also really sucks for the case 
> you want to optimize: small differences between trees, where you don't 
> need to even linearize the common parts.
>
> Why not make it just a straight fixed 12-bit prefix, single-level trie.
>   

My solution suffers from that problem too, but I personally still don't
think that the answer is to fix the trie boundary.

The only case where it hurts is when you want to merge. Nothing else
should care. So, if a merge of these note trees sees two different trie
sizes then it can convert the shorter one to the longer length first,
and then try the merge again. So you get the pain, but only once. And
when a project decides that its split is too small, it can split then
and it should "silently" spread out to others.

Sam.